-- ------------ Init --------------------
if(not INITIALIZED) then
	Graphics.freeImage(TOPBG)
	TOPBG = Graphics.loadImage(BACKGROUNDS[6])
	Graphics.freeImage(BOTTOMBG)
	BOTTOMBG = Graphics.loadImage(BACKGROUNDS[9])
	
	UIELEMENT1 = Graphics.loadImage(ELEMENTS[3])
	UIELEMENT2 = Graphics.loadImage(ELEMENTS[4])
	
	S_HIGHSCORE = nil
	S_HIGHSCORE = tostring(HIGHSCORE)
	
	uiPositions[1][1] = 0	-- cursor
	uiPositions[15][1] = 0	-- star-animation
	uiPositions[15][2] = 0	-- icon/people-animation
	
	-- -------- Blinking Icons start here ------------ --
	-- cafe-gfx
	uiPositions[2][1] = 33 	-- x
	uiPositions[2][2] = 123	-- y
	uiPositions[2][3] = 0 	-- ix
	uiPositions[2][4] = 67	-- iy
	uiPositions[2][5] = 67 	-- width
	uiPositions[2][6] = 67	-- height
	-- arrow-gfx
	uiPositions[3][1] = 308
	uiPositions[3][2] = 123
	uiPositions[3][3] = 0
	uiPositions[3][4] = 134
	uiPositions[3][5] = 67
	uiPositions[3][6] = 67
	-- home-gfx
	uiPositions[4][1] = 144
	uiPositions[4][2] = 164
	uiPositions[4][3] = 0
	uiPositions[4][4] = 201
	uiPositions[4][5] = 67
	uiPositions[4][6] = 67
	-- library-gfx
	uiPositions[5][1] = 217
	uiPositions[5][2] = 123
	uiPositions[5][3] = 0
	uiPositions[5][4] = 0
	uiPositions[5][5] = 67
	uiPositions[5][6] = 67
	-- ----------------------------------------------- --
	-- ------- Stars and People start here ----------- --
	for i = 6, 10 do
		uiPositions[i][1] = math.random(0, SCREENWIDTH-16)
		uiPositions[i][2] = 202
		uiPositions[i][3] = (math.random(0, 1)*16)
		uiPositions[i][4] = (math.random(0, 1)*16)
		uiPositions[i][5] = 16
		uiPositions[i][6] = 16
	end
	
	uiPositions[11][1] = 104
	uiPositions[11][2] = 17
	uiPositions[12][1] = 179
	uiPositions[12][2] = 45
	uiPositions[13][1] = 269
	uiPositions[13][2] = 9
	uiPositions[14][1] = 345
	uiPositions[14][2] = 96
	
	for i = 11, 14 do
		uiPositions[i][3] = (math.random(0, 3)*8)
		uiPositions[i][4] = 32
		uiPositions[i][5] = 8
		uiPositions[i][6] = 8
	end
	
	if(CSM == 0) then
		CSM = math.random(1, #SMALLTALK)
	end
	
	-- ----------------------------------------------- --
	
	if(CHUNKDATA == "") then
		CHUNKDATA = getFileInput("chunks.txt")
	end
	
	INITIALIZED = true
end

-- --------- LEFT-Screen ----------------
Graphics.initBlend(TOP_SCREEN, LEFT_EYE)
Graphics.drawImage(-1, 0, TOPBG)
--drawString(8, 8, "highscore: "..S_HIGHSCORE) unnecessary now

for i = 1, 4 do
	if(uiPositions[1][1]+1 == i) then
		Graphics.drawPartialImage(uiPositions[i+1][1]-1,uiPositions[i+1][2],uiPositions[i+1][3]+(uiPositions[15][2]*67+67),uiPositions[i+1][4],uiPositions[i+1][5],uiPositions[i+1][6],UIELEMENT1)
	else
		Graphics.drawPartialImage(uiPositions[i+1][1]-1,uiPositions[i+1][2],uiPositions[i+1][3],uiPositions[i+1][4],uiPositions[i+1][5],uiPositions[i+1][6],UIELEMENT1)
	end
end
for i = 6, 10 do
	if(uiPositions[i][3] == 16) then
		Graphics.drawPartialImage(uiPositions[i][1],uiPositions[i][2],uiPositions[i][3]-(uiPositions[15][2]*16),uiPositions[i][4],uiPositions[i][5],uiPositions[i][6],UIELEMENT2)
	else
		Graphics.drawPartialImage(uiPositions[i][1],uiPositions[i][2],uiPositions[i][3]+(uiPositions[15][2]*16),uiPositions[i][4],uiPositions[i][5],uiPositions[i][6],UIELEMENT2)
	end
end
for i = 11, 14 do
	Graphics.drawPartialImage(uiPositions[i][1]-1,uiPositions[i][2],uiPositions[i][3],uiPositions[i][4],uiPositions[i][5],uiPositions[i][6],UIELEMENT2)
end

Graphics.termBlend()

-- --------- RIGHT-Screen ---------------
Graphics.initBlend(TOP_SCREEN, RIGHT_EYE)
Graphics.drawImage(1, 0, TOPBG)
--drawString(8, 8, "highscore: "..S_HIGHSCORE)

for i = 1, 4 do
	if(uiPositions[1][1]+1 == i) then
		Graphics.drawPartialImage(uiPositions[i+1][1]+1,uiPositions[i+1][2],uiPositions[i+1][3]+(uiPositions[15][2]*67+67),uiPositions[i+1][4],uiPositions[i+1][5],uiPositions[i+1][6],UIELEMENT1)
	else
		Graphics.drawPartialImage(uiPositions[i+1][1]+1,uiPositions[i+1][2],uiPositions[i+1][3],uiPositions[i+1][4],uiPositions[i+1][5],uiPositions[i+1][6],UIELEMENT1)
	end
end
for i = 6, 10 do
	if(uiPositions[i][3] == 16) then
		Graphics.drawPartialImage(uiPositions[i][1],uiPositions[i][2],uiPositions[i][3]-(uiPositions[15][2]*16),uiPositions[i][4],uiPositions[i][5],uiPositions[i][6],UIELEMENT2)
	else
		Graphics.drawPartialImage(uiPositions[i][1],uiPositions[i][2],uiPositions[i][3]+(uiPositions[15][2]*16),uiPositions[i][4],uiPositions[i][5],uiPositions[i][6],UIELEMENT2)
	end
end
for i = 11, 14 do
	Graphics.drawPartialImage(uiPositions[i][1]+1,uiPositions[i][2],uiPositions[i][3],uiPositions[i][4],uiPositions[i][5],uiPositions[i][6],UIELEMENT2)
end

Graphics.termBlend()

-- -------- BOTTOM-Screen ---------------
Graphics.initBlend(BOTTOM_SCREEN)
Graphics.drawImage(0, 0, BOTTOMBG)
drawString(8-uiPositions[15][2], (uiPositions[1][1]*10)+8, SELTEXT[6])
drawString(20, 8, SELTEXT[1])
drawString(20, 18, SELTEXT[2])
drawString(20, 28, SELTEXT[3])
drawString(20, 38, SELTEXT[4])
drawString(20, 48, SELTEXT[5])
Graphics.termBlend()

-- ---------- Controls ------------------
-- uiPositions[1][1] -> position of the cursor on the bottom-screen
-- uiPositions[15][1]/[2] -> used to animate sprites

for i = 7, 10 do
	if(i >= 9) then
		if(uiPositions[i][1] ~= 0) then
			uiPositions[i][1] = uiPositions[i][1] - 1
		else
			uiPositions[i][1] = SCREENWIDTH-16
		end
	else
		if(uiPositions[i][1] ~= SCREENWIDTH-16) then
			uiPositions[i][1] = uiPositions[i][1] + 1
		else
			uiPositions[i][1] = 0
		end
	end
end

if(CTRLS[2] > 0) then
	if(uiPositions[1][1] ~= 4) then
		if(Timer.getTime(inputTimer) > 300) then
			Timer.reset(inputTimer)
			uiPositions[1][1] = uiPositions[1][1] + 1
		end
	end
end
if(CTRLS[1] > 0) then
	if(uiPositions[1][1] ~= 0) then
		if(Timer.getTime(inputTimer) > 300) then
			Timer.reset(inputTimer)
			uiPositions[1][1] = uiPositions[1][1] - 1
		end
	end
end

-- animation-timers
if(Timer.getTime(aniTimer) > 150) then
	
	if(uiPositions[15][1] % 2 == 0) then
		for i = 11, 14 do
			if(uiPositions[i][3] ~= 24) then
				uiPositions[i][3] = uiPositions[i][3] + 8
			else
				uiPositions[i][3] = 0
			end
		end
	end
	
	if(uiPositions[15][1] ~= 3) then
		uiPositions[15][1] = uiPositions[15][1] + 1
	else
		uiPositions[15][1] = 0
		
		-- only updates on reset... therefore slower
		if(uiPositions[15][2] == 1) then
			uiPositions[15][2] = 0
		else
			uiPositions[15][2] = 1
		end
		
	end
	
	Timer.reset(aniTimer)
end

if(A_RELEASED) then
	resetButtons()
	resetControls()
	
	pad = oldpad
	
	Graphics.freeImage(UIELEMENT1)
	Graphics.freeImage(UIELEMENT2)
	
	INITIALIZED = false
	
	if(uiPositions[1][1] == 0) then -- cafe-state
		flag = 3
	elseif(uiPositions[1][1] == 1) then -- city-state
		flag = 5
	elseif(uiPositions[1][1] == 2) then -- mia's home
		flag = 6
	elseif(uiPositions[1][1] == 3) then -- credits
		flag = 4
	elseif(uiPositions[1][1] == 4) then -- back to title-screen
		UIELEMENT1 = Graphics.loadImage("romfs:/gfx/cherrycake.png")
		-- ^ initialized and immediatly freed by title.lua
		flag = 1
	else
		-- this shouldn't happen
		System.exit()
	end
end