EFTPSZ = 0

function rotate(angle)
	-- unused
end

function changeFlag(flagnr)
	gsinit = false
	flag = flagnr
end

function split(inputstr, sep)
	-- stone 1 - ok
	-- brick 2 - nok
	-- wall  3 - unobtainable
	-- 
	if sep == nil then
		sep = "%s"
	end
	local t={}
	for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
		table.insert(t, str)
	end
	return t
end

-- ---- opens a file and returns the input ------
function getFileInput(filename)
	currentfile = io.open("romfs:/"..filename,FCREATE)
	local ipt = io.read(currentfile, 0, io.size(currentfile)+1)
	EFTPSZ = io.size(currentfile)
	io.close(currentfile)
	return ipt
end

-- ---- concatenates a table -------------------
function TableConcat(t1,t2)
    for i=1,#t2 do
        t1[#t1+1] = t2[i]
    end
    return t1
end

-- ---- 
function toBits(num, bits)
	local t={} -- will contain the bits
	for b=bits,1,-1 do
		rest=math.fmod(num,2)
		t[b]=math.floor(rest)
		num=(num-rest)/2
	end
	return t
end


function tprint (tbl, indent)
  if not indent then indent = 0 end
  for k, v in pairs(tbl) do
    formatting = string.rep("  ", indent) .. k .. ": "
    if type(v) == "table" then
      print(formatting)
      tprint(v, indent+1)
    elseif type(v) == 'boolean' then
      print(formatting .. tostring(v))      
    else
      print(formatting .. v)
    end
  end
end

function table.clone(org)
  return {table.unpack(org)}
end

function round(num, numDecimalPlaces)
  local mult = 10^(numDecimalPlaces or 0)
  return math.floor(num * mult + 0.5) / mult
end