-- This time only segmented by comments
-- ------------ Init --------------------
if(not INITIALIZED) then
	Graphics.freeImage(TOPBG)
	TOPBG = Graphics.loadImage(BACKGROUNDS[4])
	Graphics.freeImage(BOTTOMBG)
	BOTTOMBG = Graphics.loadImage(BACKGROUNDS[14])
	
	UIELEMENT1 = Graphics.loadImage(ELEMENTS[5])
	UIELEMENT2 = Graphics.loadImage(ELEMENTS[11])
	
	S_HIGHSCORE = nil
	S_HIGHSCORE = tostring(HIGHSCORE)
	
	TICTIMER = 1
	
	uiPositions[1][1] = 0	-- selected costume
	
	-- costumes are loaded here
	for i = 2, 5 do
		uiPositions[i][1] = 40
		uiPositions[i][2] = 60
		uiPositions[i][3] = (i*64-128)
		uiPositions[i][4] = 0
		uiPositions[i][5] = 64
		uiPositions[i][6] = 64
	end
	for i = 6, 9 do
		uiPositions[i][1] = 40
		uiPositions[i][2] = 60
		uiPositions[i][3] = ((i-6)*64)
		uiPositions[i][4] = 64
		uiPositions[i][5] = 64
		uiPositions[i][6] = 64
	end
	
	BGM1 = Sound.openOgg("romfs:/bgm/cafe.ogg",true)
	Sound.play(BGM1,LOOP)
	
	INITIALIZED = true
end

-- --------- LEFT-Screen ----------------
if(TICTIMER == 0) then
	if(Timer.getTime(inputTimer) >= 10) then
		Graphics.initBlend(TOP_SCREEN, LEFT_EYE)
		Graphics.drawImage(0, 0, TOPBG)
	end
elseif(TICTIMER == 1) then
	Graphics.initBlend(TOP_SCREEN, LEFT_EYE)
	Graphics.drawImage(-1, 0, TOPBG)
	Graphics.fillRect(0, SCREENWIDTH, 0, 16, c_black)
	drawString(4, 4, SMALLTALK[CSM])
	if(CSM < 8) then
	elseif(CSM >= 8 and CSM < 12) then
		Graphics.drawPartialImage(154, 115, 100, 0, 100, 100, UIELEMENT2)
	elseif(CSM >= 12 and CSM < 16) then
		Graphics.drawPartialImage(154, 115, 0, 100, 100, 100, UIELEMENT2)
	elseif(CSM >= 16 and CSM < 19) then
		Graphics.drawPartialImage(154, 115, 100, 100, 100, 100, UIELEMENT2)
	else
		Graphics.drawPartialImage(154, 115, 0, 0, 100, 100, UIELEMENT2)
	end
end

Graphics.termBlend()

-- --------- RIGHT-Screen ---------------
if(TICTIMER == 0) then
	if(Timer.getTime(inputTimer) >= 10) then
		Graphics.initBlend(TOP_SCREEN, RIGHT_EYE)
		Graphics.drawImage(0, 0, TOPBG)
	end
elseif(TICTIMER == 1) then
	Graphics.initBlend(TOP_SCREEN, RIGHT_EYE)
	Graphics.drawImage(1, 0, TOPBG)
	Graphics.fillRect(0, SCREENWIDTH, 0, 16, c_black)
	drawString(4, 4, SMALLTALK[CSM])
	
	if(CSM < 8) then
	elseif(CSM >= 8 and CSM < 12) then
		Graphics.drawPartialImage(156, 115, 100, 0, 100, 100, UIELEMENT2)
	elseif(CSM >= 12 and CSM < 16) then
		Graphics.drawPartialImage(156, 115, 0, 100, 100, 100, UIELEMENT2)
	elseif(CSM >= 16 and CSM < 19) then
		Graphics.drawPartialImage(156, 115, 100, 100, 100, 100, UIELEMENT2)
	else
		Graphics.drawPartialImage(156, 115, 0, 0, 100, 100, UIELEMENT2)
	end
end

Graphics.termBlend()

-- -------- BOTTOM-Screen ---------------
Graphics.initBlend(BOTTOM_SCREEN)
Graphics.drawImage(0, 0, BOTTOMBG)
Graphics.drawPartialImage(uiPositions[uiPositions[1][1]+2][1],uiPositions[uiPositions[1][1]+2][2],uiPositions[uiPositions[1][1]+2][3],uiPositions[uiPositions[1][1]+2][4],uiPositions[uiPositions[1][1]+2][5],uiPositions[uiPositions[1][1]+2][6],UIELEMENT1)

drawString(150, 40, COSTUMEDESC[(uiPositions[1][1]*4)+1])
drawString(150, 50, COSTUMEDESC[(uiPositions[1][1]*4)+2])
drawString(150, 60, COSTUMEDESC[(uiPositions[1][1]*4)+3])
drawString(150, 70, COSTUMEDESC[(uiPositions[1][1]*4)+4])

drawString(150, 104, ELEMENTS[8]..tostring(BUGS))
drawString(150, 118, ELEMENTS[9]..tostring(SODA))
drawString(150, 132, ELEMENTS[10]..tostring(KEYCHAINS))

if(not CAKEEATEN) then
	Graphics.drawPartialImage(190, 142, 0, 192, 64, 64, UIELEMENT1)
end
if(not COFFEE) then
	Graphics.drawPartialImage(260, 142, 64, 192, 64, 64, UIELEMENT1)
end

Graphics.termBlend()

-- ---------- Controls ------------------
if(A_RELEASED) then
	resetButtons()
	if(UNLOCKED[uiPositions[1][1]+1] == 1) then -- costume already unlocked?
		if(Timer.getTime(inputTimer) >= 200) then
			Graphics.freeImage(TOPBG)
			TOPBG = Graphics.loadImage(COSTUMES[(uiPositions[1][1]+1)])
			TICTIMER = 0
			Timer.reset(inputTimer)
			pad = oldpad
		
			AKCOSTUME = uiPositions[1][1]+1
		end
	else -- costume not unlocked
		-- ------- check if costume can be unlocked -----------
		-- bugctchr	-	20 bugs
		-- witch	-	25 keychains
		-- cafe		-	10 soda
		-- retro	-	40 bugs
		-- modern	-	40 keychains
		-- ----------------------------------------------------
		if(uiPositions[1][1]==1)then
			if(BUGS >= 20)then
				BUGS = BUGS-20
				UNLOCKED[2] = 1
			end
		elseif(uiPositions[1][1]==2)then
			if(KEYCHAINS >= 25)then
				KEYCHAINS = KEYCHAINS-25
				UNLOCKED[3] = 1
			end
		elseif(uiPositions[1][1]==3)then
			if(SODA >= 10)then
				SODA = SODA-10
				UNLOCKED[4] = 1
			end
		elseif(uiPositions[1][1]==4)then
			if(BUGS >= 40)then
				BUGS = BUGS-40
				UNLOCKED[5] = 1
			end
		elseif(uiPositions[1][1]==5)then
			if(KEYCHAINS >= 40)then
				KEYCHAINS = KEYCHAINS-40
				UNLOCKED[6] = 1
			end
		else
			CSM = 1
		end
	end
end

if(B_RELEASED) then
	resetButtons()
	INITIALIZED = false
	
	Sound.pause(BGM1)
	Sound.close(BGM1)
	
	flag = 2
end

if(CTRLS[9] == 1 and (not CAKEEATEN)) then
	CTRLS[9] = 0
	if(SODA >= 2) then
		SODA = SODA-2
		CAKEEATEN = true
	else
		CSM = 1
	end
end

if(CTRLS[10] == 1 and (not COFFEE)) then
	CTRLS[10] = 0
	pad = oldpad
	if(SODA >= 10) then
		SODA = SODA-10
		COFFEE = true
	else
		CSM = 1
	end
end

if(CTRLS[3] > 0) then
	if(Timer.getTime(inputTimer) >= 300) then
		resetControls()
	
		pad = oldpad
	
		if(uiPositions[1][1] ~= 0) then
			uiPositions[1][1] = uiPositions[1][1]-1
		end
		
		Timer.reset(inputTimer)
	end
elseif(CTRLS[4] > 0) then
	if(Timer.getTime(inputTimer) >= 300) then
		resetControls()
	
		pad = oldpad
	
		if(uiPositions[1][1] ~= 5) then
			uiPositions[1][1] = uiPositions[1][1]+1
		end
		
		Timer.reset(inputTimer)
	end
end

if(TICTIMER == 0) then
	if(Timer.getTime(inputTimer) >= 1200) then
		TICTIMER = 1
		Graphics.freeImage(TOPBG)
		TOPBG = Graphics.loadImage(BACKGROUNDS[4])
	end
end