-- ------------ Init --------------------
if(not INITIALIZED) then
	
	uiPositions[1][1] = 0
	
	Graphics.freeImage(TOPBG)
	TOPBG = Graphics.loadImage(BACKGROUNDS[2])
	Graphics.freeImage(BOTTOMBG)
	BOTTOMBG = Graphics.loadImage(BACKGROUNDS[8])
	
	Graphics.freeImage(UIELEMENT1)
	UIELEMENT1 = Graphics.loadImage(ELEMENTS[2])
	
	INITIALIZED = true
	
end

-- --------- LEFT-Screen ----------------
Graphics.initBlend(TOP_SCREEN, LEFT_EYE)
Graphics.drawImage(-1, 0, TOPBG)

Graphics.drawImage((SCREENWIDTH-247), uiPositions[1][1], UIELEMENT1)
Graphics.termBlend()

-- --------- RIGHT-Screen ---------------
Graphics.initBlend(TOP_SCREEN, RIGHT_EYE)
Graphics.drawImage(1, 0, TOPBG)
Graphics.drawImage((SCREENWIDTH-247), uiPositions[1][1], UIELEMENT1)
Graphics.termBlend()

-- -------- BOTTOM-Screen ---------------
Graphics.initBlend(BOTTOM_SCREEN)
Graphics.drawImage(0, 0, BOTTOMBG)
Graphics.fillRect(0, SCREENWIDTH, SCREENHEIGHT/2-8, SCREENHEIGHT/2+8, c_black)
drawString(SCREENWIDTH/2-80, SCREENHEIGHT/2-4, "press start")
Graphics.termBlend()

-- ---------- Controls ------------------
if(Timer.getTime(aniTimer) > 100) then
	
	Timer.reset(aniTimer)
	
	if(mUp) then
		
		if(uiPositions[1][1] ~= 10) then
			uiPositions[1][1] = uiPositions[1][1] + 1
		else
			mUp = false
		end
	else
		
		if(uiPositions[1][1] ~= 0) then
			uiPositions[1][1] = uiPositions[1][1] - 1
		else
			mUp = true
		end
	end
end

if(CTRLS[5] > 0) then
	Graphics.freeImage(UIELEMENT1)
	pad = oldpad
	INITIALIZED = false
	flag = 2
end

if(A_RELEASED) then
	resetButtons()
end

if(B_RELEASED) then
	resetButtons()
end